<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="areaName">
        <el-input
          v-model="queryParams.areaName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input
          v-model="queryParams.sort"
          placeholder="请输入排序"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="是否删除" prop="isDel">
        <el-input
          v-model="queryParams.isDel"
          placeholder="请输入是否删除"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['core:gridInfo:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['core:gridInfo:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['core:gridInfo:remove']"
        >删除</el-button>
      </el-col>
      <!-- <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['core:gridInfo:export']"
        >导出</el-button>
      </el-col> -->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="gridInfoList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="网格id" align="center" prop="id" />
      <el-table-column label="名称" align="center" prop="areaName" />
      <el-table-column label="排序" align="center" prop="sort" />
      <el-table-column label="区域/网格" align="center" prop="type">
         <template slot-scope="scope">
           <span>{{scope.row.type == 0 ? '区域' : '网格'}}</span>
         </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['core:gridInfo:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['core:gridInfo:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改网格信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="600px" append-to-body>

      <el-form ref="form" :model="form" :rules="rules" label-width="120px">
        <el-form-item label="网格或区域" prop="type">
         <el-select @change="nhueoswe" v-model="form.type" placeholder="选择是网格或是区域" clearable style="width: 100%;">
         	<el-option v-for="dict in typeOptionstyzandeh" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
         </el-select>
        </el-form-item>
        <el-form-item label="父类网格" prop="pid" v-if="shoue">
         <el-select v-model="form.pid" placeholder="选择父类网格" clearable style="width: 100%;">
         	<el-option v-for="dict in typeOptionstyzandehfl" :key="dict.dictValue" :label="dict.areaName" :value="dict.id" />
         </el-select>
        </el-form-item>
        <el-form-item label="名称" prop="areaName">
          <el-input v-model="form.areaName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="排序" prop="sort">
          <el-input v-model="form.sort" placeholder="请输入排序" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listGridInfo, getGridInfo, delGridInfo, addGridInfo, updateGridInfo,listRoleergthwg } from "@/api/core/gridInfo";

export default {
  name: "GridInfo",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 网格信息表格数据
      gridInfoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        areaName: null,
        gridName: null,
        sort: null,
        type: null,
        isDel: null
      },
      typeOptionstyzandehfl:[],
      typeOptionstyzandeh:[
        {
          dictValue: 0,
				  dictLabel: '区域',
          },
          {
            dictValue: 1,
            dictLabel: '网格',
            }
          ],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        areaName: [
          { required: true, message: "区域名称不能为空", trigger: "blur" }
        ],
        sort: [
          { required: true, message: "排序不能为空", trigger: "blur" }
        ],
        type: [
          { required: true, message: "网格或区域不能为空", trigger: "blur" }
        ]
      },
      shoue:false
    };
  },
  created() {
    this.getList();
    this.mnyesfjeropwg(0)
  },
  methods: {
    /** 查询网格信息列表 */
    getList() {
      this.loading = true;
      listGridInfo(this.queryParams).then(response => {
        this.gridInfoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    mnyesfjeropwg(index){
      this.loading = true;
      let pids = {}
      pids.pid= index
      listRoleergthwg(pids).then(response => {
      	this.typeOptionstyzandehfl = response.data;
      	this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        areaName: null,
        gridName: null,
        sort: null,
        type: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
        isDel: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加网格信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getGridInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改网格信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateGridInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addGridInfo(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.confirm('是否确认删除网格信息编号为"' + ids + '"的数据项？').then(function() {
        return delGridInfo(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('core/gridInfo/export', {
        ...this.queryParams
      }, `gridInfo_${new Date().getTime()}.xlsx`)
    },
    nhueoswe(data){
       console.log(data)
       if(data == 0){
         //区域
         this.shoue = false
       }else{
         //网格
         this.shoue = true
       }
    }
  }
};
</script>
